#ifndef __FCAPalette_APPVIEW_H__
#define __FCAPalette_APPVIEW_H__


#include <coecntrl.h>

class CFCAPaletteAppView : public CCoeControl
    {
public:

    static CFCAPaletteAppView* NewL(const TRect& aRect);
    static CFCAPaletteAppView* NewLC(const TRect& aRect);
    ~CFCAPaletteAppView();
    void PrintLineL(const TDesC& aText);
    void PrintLine2L(TBuf<256> textbuf);

public: // from CoeControl

    TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);
    TInt CountComponentControls() const;
    CCoeControl* ComponentControl(TInt aIndex) const;

private:
    void ConstructL(const TRect& aRect);
    CFCAPaletteAppView();

private:

    /*! @var iListBox the control used to display the results */
    CAknSingleStyleListBox* iListBox;

    /*! @var iMessageList the list of messages to display */
    CDesCArrayFlat* iMessageList;

    /*! @var iMsgIndex the id for the next message in the list */
    TInt iMsgIndex;

    /*! @var iOutputText the next string to be added on invoking PrintLineL */
    HBufC*  iOutputText;
    };


#endif // __FCAPalette_APPVIEW_H__
